; Hello world
          jmp Start
.ORG 0040h
.dseg
mystring  .text "Hello world"
.cseg
          
Start:    lxi  sp, 4700h   ; Set Stack Address
          
          mvi  a, 82h      ; CW
          sta  5803h       ; 8255A Write Control Word 
          xra  a
          sta  5802h       ; 0 -> PortC: stop motors

          mvi  a, 0Ch      ; LCD Command: Display on, cursor off
          call sub_1B70    ; Command -> LCD

          lxi  h, mystring ; Address of text
          mvi  b, 0Bh      ; Number of characters
Loc01:    mov  a, m
          call sub_1B77    ; Data -> LCD
          inx  h           ; Address of next characters
          dcr  b           ; Decrement counter
          jnz  Loc01

Stop:     jmp  Stop        ; Neverending loop           
          hlt              ; For sure

; Write 1 byte command
sub_1B70: call sub_1B7E    ; Wait for LCD ready
          sta  4802h       ; Write byte 
          ret
          
; Write 1 byte data
sub_1B77: call sub_1B7E    ; Wait for LCD ready
          sta  4803h       ; Write byte
          ret
                  
; Wait for LCD ready
sub_1B7E: push psw
loc_1B7F: lda  4800h       ; Read LCD status
          ani  80h         ; Test bit 7: 0 = ready
          jnz  loc_1B7F
          pop  psw
          ret

.END
